/*
 * Common.h
 *
 *  Created on: Jan 22, 2013
 *      Author: tuleu
 */


#include <tr1/memory>
#include <cmath>
#include <sstream>
#include <stdexcept>

#ifndef LIBONCILLA_WEBOTS_COMMON_H_
#define LIBONCILLA_WEBOTS_COMMON_H_

#include <liboncilla/exceptions/NotImplementedError.h>

#define NOT_IMPLEMENTED_STUB(className,methodName) do{\
	throw rci::oncilla::NotImplementedError("liboncilla-webots",#methodName,#className);\
}while(0)



namespace webots {

	class Supervisor;
	class Robot;

} /* namespace webots */


//this is the only ressource we should delete from webots.
//all the rest are managed internally in webots, we should not delete the
//pointers, I agree this is a really bad design but I do not design
//the library

typedef std::tr1::shared_ptr<webots::Supervisor> WSupervisorPtr;
typedef std::tr1::shared_ptr<webots::Robot>      WRobotPtr;

namespace liboncilla{
namespace webots {

template <typename T>
T clamp(T value, T lowBound, T highBound){
	if(lowBound > highBound){
		std::ostringstream os;
		os << "Invalid interval passed to clamp, minimal value ("
		   << lowBound << " )  > maximal value (" << highBound << ")";
		throw std::invalid_argument(os.str());
	}
	return std::min(std::max(lowBound,value),highBound);
}

}
}



#endif /* COMMON_H_ */
