/**
 * \file WebotsNodeWrapper.cpp
 *
 *  \date Jun 27, 2012
 *  \author Alexandre Tuleu
 */

#include "WebotsNodeWrapper.h"

#include <stdexcept>

#include <webots/Supervisor.hpp>




WebotsNodeWrapper::WebotsNodeWrapper(webots::Supervisor & supervisor,
                                     const std::string & name)
	: d_name(name){
	d_node = supervisor.getFromDef(name);
	if(!d_node){
		throw std::runtime_error("[WebotsNodeWrapper] : could not find node '" + name + "'");
	}
}

WebotsNodeWrapper::~WebotsNodeWrapper(){}

int WebotsNodeWrapper::Type() const{
	return d_node->getType();
}

