/**
 * \file L1.h
 *
 *  \date Jan 22, 2013
 *  \author tuleu
 */

#ifndef LIBONCILLA_WEBOTS_L1_H_
#define LIBONCILLA_WEBOTS_L1_H_

#include <liboncilla/nodes/L1L2.h>
#include "NodeAdapter.h"
#include <liboncilla-webots/Common.h>

namespace webots {
	class Servo;
}

class WebotsNodeWrapper;



namespace liboncilla {
namespace webots {

class L1 : public rci::oncilla::L1,
           public NodeAdapter {
public:
	L1(rci::oncilla::Synchronizer & s,
	   const std::string & name,
	   ::webots::Servo * servo,
	   const WebotsNodeWrapper & wNode );
	virtual ~L1();

	virtual void PreStep(double ts);

	virtual void PostStep(double ts);

	virtual void Activate();



private :

	::webots::Servo & d_servo;
	unsigned int    d_initialPasses;
	double d_lastServoPosition;
	double d_rate;
	double d_desiredPosition;
	const double d_minPosition;
	const double d_maxPosition;
	const double d_maxServoForce;
	const double d_maxVelocity;


};

} /* namespace webots */
} /* namespace liboncilla */
#endif /* LIBONCILLA_WEBOTS_L1_H_ */
