/**
 * \file L3.cpp
 *
 *  \date Jan 22, 2013
 *  \author tuleu
 */

#include "L3.h"

#include <liboncilla-webots/Common.h>
#include <webots/Servo.hpp>

namespace liboncilla {
namespace webots {

L3::L3(const std::string & name,
	   ::webots::Servo * servo)
	: rci::oncilla::L3(name)
	, d_servo(*servo){
	if(!servo){
		throw std::out_of_range("Could not find webots servo for '" + name + "'");
	}
}

L3::~L3(){
}

void L3::Activate(){
	d_servo.enablePosition(1);
}

void L3::Deactivate(){
	d_servo.disablePosition();
}

void L3::PostStep(double ){
	_latestJointPosition->setFromRad(0,d_servo.getPosition());
}

} /* namespace webots */
} /* namespace liboncilla */
