/**
 * \file NodeAdapter.cpp
 *
 *  \date Jan 22, 2013
 *  \author tuleu
 */

#include "NodeAdapter.h"

namespace liboncilla {
namespace webots {

NodeAdapter::ListOfInstances NodeAdapter::s_instances;

NodeAdapter::NodeAdapter(){
	s_instances.insert(this);
}

NodeAdapter::~NodeAdapter(){
	s_instances.erase(this);
}

void NodeAdapter::PreStep(double){
}

void NodeAdapter::PostStep(double){
}

void NodeAdapter::Activate(){
}

void NodeAdapter::Deactivate(){
}


void NodeAdapter::IterateOverAllInstances(std::mem_fun_t<void,NodeAdapter> f){
	for(ListOfInstances::const_iterator i = s_instances.begin();
	    i != s_instances.end();
	    ++i){
		f(*i);
	}
}


} /* namespace webots */
} /* namespace liboncilla */
