/**
 * \file SupervisorTrunk.cpp
 *
 *  \date Jan 22, 2013
 *  \author tuleu
 */

#include "SupervisorTrunk.h"

#include <liboncilla-webots/Common.h>

namespace liboncilla {
namespace webots {

SupervisorTrunk::SupervisorTrunk(::webots::Node * node)
	: d_node(node){
	if(node == NULL){
		throw std::runtime_error("Could not find suitable node for SupervisorTrunk");
	}
}

SupervisorTrunk::~SupervisorTrunk(){
}

void SupervisorTrunk::PostStep(double ){
	const double * P(d_node->getPosition());
	const double * R(d_node->getOrientation());
	if(P == NULL || R == NULL){
		throw std::runtime_error("COuld not read out position and orientation of trunk.");
	}


	rci::TranslationPtr position(rci::Translation::fromMeters(P[0],
	                                                          P[1],
	                                                          P[2]));

	rci::OrientationPtr orientation(rci::Orientation::fromRotationMatrix(R[0],R[1],R[2],
	                                                                     R[3],R[4],R[5],
	                                                                     R[6],R[7],R[8]));

	this->updatePose(position,orientation);

}

} /* namespace webots */
} /* namespace liboncilla */
