/**
 * \file Trunk.h
 *
 *  \date Jan 22, 2013
 *  \author tuleu
 */

#ifndef LIBONCILLA_WEBOTS_TRUNK_H_
#define LIBONCILLA_WEBOTS_TRUNK_H_

#include <liboncilla/nodes/Trunk.h>
#include "NodeAdapter.h"
#include <liboncilla-webots/Common.h>

#include <Eigen/Geometry>

#include <webots/Node.hpp>

namespace liboncilla {
namespace webots {

class Trunk : public rci::oncilla::Trunk,
              public NodeAdapter{
public:
	Trunk(::webots::Node * node);
	virtual ~Trunk();

	virtual void PostStep(double ts);

	EIGEN_MAKE_ALIGNED_OPERATOR_NEW_IF_VECTORIZABLE_FIXED_SIZE(double,16);
private :
	::webots::Node * d_node;
	Eigen::Vector3d   d_position;
	Eigen::Vector3d   d_velocity;
	unsigned int d_initialized;
};

} /* namespace webots */
} /* namespace liboncilla */
#endif /* LIBONCILLA_WEBOTS_TRUNK_H_ */
